﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace CAN_2088C_demo
{
    public partial class Form1 : Form
    {

        System.Windows.Forms.Timer Timer1 = new System.Windows.Forms.Timer();
        UInt16 TxPDO5 = 0;
        Byte VxCAN=0;
        public Form1()
        {
            InitializeComponent();
            Timer1.Tick += new EventHandler(Timer1_Tick);
        }

        //get VxCAN_DotNET.dll version
        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            }
        }

        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;

            Byte COMPortListCount = 0, BaudRateListCount, DataBitsListCount, StopBitsListCount, ParityListCount, CheckSumListCount;
            Byte[] COMPortList = new Byte[255];
            UInt32[] BaudRateList, DataBitsList, StopBitsList, ParityList, CheckSumList;

            //The VxCAN_SearchCANModule() will search with 2400~921600bps and 5~8 data-bits.
            //It will cost almost 5~10 minutes.
            //ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();

            //===================================================================//
            //The user can use VxCAN_SearchCANModuleExAll() instead.
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_GetCurrentCOMPorts(ref COMPortListCount, COMPortList);
            BaudRateList = new UInt32[] { 921600, 115200 };
            DataBitsList = new UInt32[] { 8 }; //8 data-bit
            StopBitsList = new UInt32[] { 1 }; //1 stop-bit
            ParityList = new UInt32[] { 0 }; //0: None parity
            CheckSumList = new UInt32[] { 0, 1 }; //0: Disable Checksum, 1:Enable Checksum
            BaudRateListCount = (Byte)BaudRateList.Count();
            DataBitsListCount = (Byte)DataBitsList.Count();
            StopBitsListCount = (Byte)StopBitsList.Count();
            ParityListCount = (Byte)ParityList.Count();
            CheckSumListCount = (Byte)CheckSumList.Count();
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModuleExAll(
                                            COMPortListCount, COMPortList,
                                            BaudRateListCount, BaudRateList,
                                            DataBitsListCount, DataBitsList,
                                            StopBitsListCount, StopBitsList,
                                            ParityListCount, ParityList,
                                            CheckSumListCount, CheckSumList);
            //===================================================================//

            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort = 0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");



            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0', 50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];

                    //2088C is not a UART module so its VxCAN_COMPortBaudRate = 0xFFFFFFFF
                    //we use -1 to represent that
                    if (_VxCAN_COMPortBaudRate[i] == 0xFFFFFFFF)
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = -1;
                    else
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }
            }
        }

        //default CAN baud rate is 1000Kbps, use that open CAN port
        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN((byte)dataGridView1.CurrentRow.Index, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port done!!");
            }
            VxCAN = (byte)dataGridView1.CurrentRow.Index;
        }

        //close CAN port
        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(0);
        }

        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(0);
            if (ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(0, ref ModuleStatus, ref CANChipStatus);
            if (ret == 0)
            {
                MessageBox.Show("Module Status = " + ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        private void Btn_OperationMode_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            ID = 0x000;
            Len = 0x2;
            Data[0] = 0x01;
            Data[1] = DataID;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            MessageBox.Show("CAN2088C is in operation mode!");

            //-----------Set counter 6 & 7 PDO--------------------------------------------

           

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x04;
            Data[2] = 0x1A;
            Data[3] = 0x00;
            Data[4] = 0x02;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Thread.Sleep(50);

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x23;
            Data[1] = 0x04;
            Data[2] = 0x18;
            Data[3] = 0x01;
            if (NumID == 0x7F)
            {
                TxPDO5 = (UInt16)(0x280 + NumID - 1);
                Data[4] = (byte)(TxPDO5 % 256);
                Data[5] = (byte)(TxPDO5 / 256);
                
            }
            else
            {
                TxPDO5 = (UInt16)(0x280 + NumID + 1);
                Data[4] = (byte)(TxPDO5 % 256);
                Data[5] = (byte)(TxPDO5 / 256);
                
            }
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Thread.Sleep(50);

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x04;
            Data[2] = 0x18;
            Data[3] = 0x02;
            Data[4] = 0xFF;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //-----------------------------------------------------------------------------

        }
        
        //Start PWM output
        private void Btn_PWMoutput_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            UInt32 duty = 500;
            UInt32 freq = 2;
            int channel = (comboBox2.SelectedIndex + 1);
            
            //-----------Set Frequency--------------------------------------------------
            //Clean buffer for Latest Data
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);
            
            freq = UInt32.Parse(textBox1.Text);
            if (freq > 5000000 || freq < 2)
                MessageBox.Show("Frequency out of range!!");
            else
            {
                ID = 0x600 + NumID;
                Len = 0x8;
                Data[0] = 0x23;
                Data[1] = 0x02;
                Data[2] = 0x31;
                Data[3] = (byte)(channel);
                Data[4] = (byte)(freq % 256);
                Data[5] = (byte)((freq % (256*256)) / 256);
                Data[6] = (byte)(freq / (256*256));
                Data[7] = 0x00;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            }
            //--------------------------------------------------------------------------


            //-----------Set Duty cycle-------------------------------------------------
            //Clean buffer for Latest Data
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            duty = UInt32.Parse(textBox2.Text);
            if (duty > 999 || duty < 1)
                MessageBox.Show("Duty cycle out of range!!");
            else
            {
                ID = 0x600 + NumID;
                Len = 0x8;
                Data[0] = 0x2B;
                Data[1] = 0x03;
                Data[2] = 0x31;
                Data[3] = (byte)(channel);
                Data[4] = (byte)(duty % 256);
                Data[5] = (byte)(duty / 256);
                Data[6] = 0x00;
                Data[7] = 0x00;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            }
            //---------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Output----------------------------------------------------
            //Clean buffer for Latest Data
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x31;
            Data[3] = (byte)(channel);
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            //--------------------------------------------------------------------------
            

        }
        //Stop PWM output
        private void Btn_StopPWM_Click_1(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            //-----------Stop Output--------------------------------------------------
            //Clean buffer for Latest Data
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x31;
            Data[3] = (byte)(comboBox2.SelectedIndex + 1);
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            //-------------------------------------------------------------------------

            

        }

        private void Timer1_Tick(object sender, System.EventArgs e)
        {
            //Initialize parameters
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            byte VxCANPort = VxCAN, rMode = 0, rRTR = 0, rLen = 0;
            byte[] rData = new Byte[8];
            UInt32 ret = 0, rID = 0;
            Double rMsgTimeStamps = 0;
            int a = 0x0;    

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(VxCANPort, ref rID, ref rMode, ref rRTR, ref rLen, rData, ref rMsgTimeStamps);
            if (ret == 0)
            {
                //Clean buffer for Latest Data
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

                if (rID == (0x280 + NumID))
                {
                    //counter0
                    a = rData[3] * 256 * 256 * 256 + rData[2] * 256 * 256 + rData[1] * 256 + rData[0];
                    Counter0.Text = a.ToString();
                    //counter1
                    a = rData[7] * 256 * 256 * 256 + rData[6] * 256 * 256 + rData[5] * 256 + rData[4];
                    Counter1.Text = a.ToString();

                }
                if (rID == (0x380 + NumID))
                {
                    //counter2
                    a = rData[3] * 256 * 256 * 256 + rData[2] * 256 * 256 + rData[1] * 256 + rData[0];
                    Counter2.Text = a.ToString();
                    //counter3
                    a = rData[7] * 256 * 256 * 256 + rData[6] * 256 * 256 + rData[5] * 256 + rData[4];
                    Counter3.Text = a.ToString();
                }
                if (rID == (0x480 + NumID))
                {
                    //counter4
                    a = rData[3] * 256 * 256 * 256 + rData[2] * 256 * 256 + rData[1] * 256 + rData[0];
                    Counter4.Text = a.ToString();
                    //counter5
                    a = rData[7] * 256 * 256 * 256 + rData[6] * 256 * 256 + rData[5] * 256 + rData[4];
                    Counter5.Text = a.ToString();
                }
                if (rID == TxPDO5)
                {
                    //counter4
                    a = rData[3] * 256 * 256 * 256 + rData[2] * 256 * 256 + rData[1] * 256 + rData[0];
                    Counter6.Text = a.ToString();
                    //counter5
                    a = rData[7] * 256 * 256 * 256 + rData[6] * 256 * 256 + rData[5] * 256 + rData[4];
                    Counter7.Text = a.ToString();
                }

            }
        }

        private void btn_StartCounter_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];
            //-----------Start Counter 0 & 1 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x01;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0xF4;
            Data[5] = 0x01;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(70);
            //-----------Start Counter 2 & 3 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x02;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0xF4;
            Data[5] = 0x01;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(70);
            //-----------Start Counter 4 & 5 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x03;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0xF4;
            Data[5] = 0x01;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(70);
            //-----------Start Counter 6 & 7 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x04;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0xF4;
            Data[5] = 0x01;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Timer1.Interval = 10;
            Timer1.Enabled = true;
            //--------------------------------------------------------------------------
        }

        private void btn_ClearCounter_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            Counter0.Text = "0";
            Counter1.Text = "0";
            Counter2.Text = "0";
            Counter3.Text = "0";
            Counter4.Text = "0";
            Counter5.Text = "0";
            Counter6.Text = "0";
            Counter7.Text = "0";

            //-----------Start Counter 0 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x01;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Counter 1 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x02;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Counter 2 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x03;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Counter 3 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x04;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Counter 4 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x05;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Counter 5 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x06;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Counter 6 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x07;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
            Thread.Sleep(50);
            //-----------Start Counter 7 ---------------------------------------------
            //Set 1 second interval of event timer 
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x02;
            Data[2] = 0x30;
            Data[3] = 0x08;
            Data[4] = 0x01;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            //--------------------------------------------------------------------------
        }

        private void btn_StopCounter_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            //-----------Stop counter ----------------------------------------------------

            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x01;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Data[0] = 0x2B;
            Data[1] = 0x02;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Data[0] = 0x2B;
            Data[1] = 0x03;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Data[0] = 0x2B;
            Data[1] = 0x04;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Timer1.Enabled = false;
            //--------------------------------------------------------------------------
        }

        

        
    }
}
